<?php
/**
	@file dom.php
	Fichero con la clase Dom.
	@copy Copyright Ilke Benson 2008
	@author Miguel Jaque Barbero (mjaque@ilkebenson.com)
	@version 1.0
	@date 2008-02-06

**/

/**	Clase abstracta para la derivación de objetos de dominio.
 	Reúne los métodos comunes para todos los objetos de dominio.
	La responsabilidad de las clases de dominio es ejecutar la lógica de negocio de la aplicacion, pero sin conocer ni los interfaces de usuario ni los sistemas de datos utilizados.
**/
abstract class Dom{
	/**	Devuelve o establece el valor de un atributo.
		Si se llama con un sólo parámetro, realizará la consulta del atributo. Si se llama con dos, realizará la modificación.
		Esta función puede ser sobreescrita por las clases derivadas para controlar el acceso a atributos protegidos o privados.
		@param $nombre Nombre del atributo.
		@param $valor Valor del atributo.
		@return El valor del atributo consultado o true si es una modificación.
	 **/
	public function atr($nombre, $valor){
		//Probar a utilizar __get y __set http://www.php.net/manual/es/language.oop5.overloading.php
		if (!isset($valor)) return $this->${'nombre'};
		else $this->${'nombre'} = $valor;
		return true;
	}
	/**	Devuelve la lista de atributos públicos de un objetos.
		Esta función es utilizada por la clase XML para convertir un objeto en un documento xml.
		Si los atributos son privados para encapsularlos, debe sobreescribirse esta función.
		@return Array indexado con los valores de los atributos del objeto. El índice es el nombre del atributo.
	**/
	public function verAtributos(){
		return get_object_vars($this);
	}

}

return true;	//Indicador de carga para __autoload
?>
