<?php
/**
	@file campoListaDesplegableAmpliable.php
	Fichero de la clase del campoListaDesplegableAmpliable.
	Copyright Ilke Benson 2008
	@author Miguel Jaque Barbero (mjaque@ilkebenson.com)
	@version 1.0
	@date 2008-04-23
**/

/**	Representa un campo de lista desplegable que puede ser ampliada. 
	Está formado por un span que contiene un select, un input-text y un input-button.
**/
class CampoListaDesplegableAmpliable extends CampoListaDesplegable{
	protected $atributos = array('id','clase','lista','editable','tabindex');

	/**	Devuelve el nodo que constituye el campo.
		@return DOMElement con el nodo que representa el campo
	**/
	public function verNodo(){
		$xml = new DOMDocument();
	
		// Creamos el nodo del campo de texto
		$input = $xml->createElement("input");
		$input->setAttribute("type", "text");
	//	$input->setAttribute("size", "10");
		$input->setAttribute("maxlength", "10");
		$input->setAttribute("id", "texto".ucfirst($this->id));
		$input->setAttribute("name", "texto".ucfirst($this->id));
		if ($this->editable == 'no')
			$input->setAttribute("disabled", "disabled");
		if (isset($this->clase))
			$input->setAttribute("class", $this->clase);
		if (isset($this->tabindex))
			$input->setAttribute("tabindex", $this->tabindex);

		// Sacamos el nodo del select de la clase ListaDesplegable
		$selectPadre = parent::verNodo();
		$select = $xml->importNode($selectPadre, true);
		$select->setAttribute('id', 'lista'.ucfirst($this->id));

		// Creamos el botón para añadir
		$boton = $xml->createElement('img');
		$boton->setAttribute('id', 'boton'.ucfirst($this->id));
		$boton->setAttribute('src', 'iu/img/edit.png');
		if ($this->editable == 'no')
			$boton->setAttribute("disabled", "disabled");

		// Creamos un span para unirlos
		$span = $xml->createElement("span");
		$span->setAttribute("id", $this->id);
		$span->appendChild($input);
		$span->appendChild($select);
		$span->appendChild($boton);

		return $span;
	}
}

///	Excepciones.

return true;	//Indicador de carga para __autoload
?>
