<?php
/**
	@file autoload.php
	Fichero con la función de autocarga de clases.
	Copyright Ilke Benson 2008
	@author Miguel Jaque Barbero (mjaque@ilkebenson.com)
	@version 1.0
	@date 2008-01-21

**/

/**	Carga la clase solicitada.
	@param $clase Nombre de la clase.
**/
function __autoload($clase){
	//$clase = strtolower($clase);
	$primeraLetra = substr($clase,0,1);
	$clase = substr_replace($clase, strtolower($primeraLetra),0,1);

	//Buscamos en los directorios de IU, APP, DOM y SERVICIOS
	$dirs = array(DIR_IU, DIR_APP, DIR_DOM, DIR_DAT, DIR_SERV);
	$nivelAnterior = error_reporting(E_ERROR);			//Evitamos los mensajes al fallar el include.
	foreach ($dirs as $dir)
		if(include($dir.$clase.".php")){
			error_reporting($nivelAnterior);
			return;
		}

	error_reporting($nivelAnterior);
	throw new ExcepcionAutoloadClaseNoEncontrada($clase);
}

//// 	Excepción de clase no encontrada.
class ExcepcionAutoloadClaseNoEncontrada extends Excepcion{
	public function __construct($clase){
		$titulo = "No se pudo cargar la clase $clase";
		$texto = "La aplicación no encontró la clase $clase en ninguno de los archivos.";
		$solucion = "Compruebe el nombre de la clase y los directorios definidos en el fichero de configuración.";
		parent::__construct($titulo,$texto,$solucion);
	}
}
?>
