<?php
/**
	@file debug.php
	Fichero con la clase estÃÂ¡tica Debug, el depurador.
	&copy Copyright Ilke Benson 2007
	@author Miguel Jaque Barbero (mjaque@ilkebenson.com)
	@version 1.0
	@date 2007-12-23

**/

class Debug{
/**-	Depurador.
	Permite escribir comentarios en un fichero de log.
**/
	//ConfiguraciÃÂ³n
	const DEBUG = true;			//Activa o desactiva la depuraciÃÂ³n.
	const FICHERO = "/tmp/pax.log";		//Fichero de log por defecto.
	const NIVEL = "E_USER_ERROR | E_USER_WARNING | E_USER_NOTICE";	//Establece el nivel de depuraciÃÂ³n por defecto.
	const FORMATO_FECHA = "Y-m-d H:i:s";

	//Atributos
	public static $debug = self::DEBUG;
	public static $fichero = self::FICHERO;
	public static $nivel = self::NIVEL;
	public static $formatoFecha = self::FORMATO_FECHA;

	public static function anotar($msg){
	/**-	Escribe un mensaje en el fichero de log.
		@param $msg Texto del mensaje.
	**/
		if (!self::$debug) return;
		$fichero = fopen(self::$fichero, "a");
		if (!$fichero) throw new Exception(3);
		error_reporting(self::$nivel);
		$msg = date("Y-m-d H:m:s")." - ".$msg."\n";
		fwrite($fichero, $msg);
	}
	public static function gestionarError($numError, $mensaje, $fichero, $lÃÂ­nea){
	/**-	Gestiona los errore producidos en la aplicaciÃÂ³n.
		El ÃÂºnico tratamiento es escribir los datos del error en el fichero de log.
		@param $numError NÃÂºmero del Error
		@param $mensaje Mensaje de Error, que se escribirÃÂ¡ en el log.
		@param $fichero Nombre del fichero de cÃÂ³digo php en el que se ha producido el error.
		@param $lÃÂ­nea NÃÂºmero de la lÃÂ­nea del fichero en la que se ha producido el error.
	**/
		#echo "En gestionarError $numError $mensaje $fichero $lÃÂ­nea";

		if (!self::$debug) return;

		if ($numError == 2048) return; //para elminiar los errores del tipo DEPRECATED 
		switch($numError){
			case E_USER_ERROR:
				self::anotar("ERROR [$numError] $mensaje.\nEn el fichero $fichero, lÃÂ­nea $lÃÂ­nea.\nAbortando");
   				exit(1);
				break;
			case E_USER_WARNING:
   				self::anotar("Warning [$numError] $mensaje.\nEn el fichero $fichero, lÃÂ­nea $lÃÂ­nea.");
   				break;
			case E_USER_NOTICE:
   				self::anotar("Aviso [$numError] $mensaje.\nEn el fichero $fichero, lÃÂ­nea $lÃÂ­nea.");
   				break;
			default:
   				self::anotar("Mensaje [$numError] $mensaje.\nEn el fichero $fichero, lÃÂ­nea $lÃÂ­nea.");
   			break;
		}
		return;
	}
}

//Debug::anotar('Definida la clase Debug.'); //AnotarÃÂ¡ en el fichero por defecto si se descomenta.
return true;	//Indicador de carga para __autoload
?>
