<?php
/**
	@file registro.php
	Fichero con la clase Registro de Operaciones.
	@copy Copyright Ilke Benson 2008
	@author Miguel Jaque Barbero (mjaque@ilkebenson.com)
	@version 1.0
	@date 2008-01-24

**/

/**	Registro de Operaciones (clase estática).
	Permite escribir comentarios en un fichero de log.
**/
class Registro{
	//Configuración
	const FICHERO = "/tmp/pax.log";		//Fichero de log por defecto.
	const FORMATO_FECHA = "Y-m-d H:i:s";

	//Atributos
	public static $fichero = self::FICHERO;
	public static $formatoFecha = self::FORMATO_FECHA;

	/**	Escribe un mensaje en el fichero de log.
		@param $msg Texto del mensaje.
	**/
	public static function anotar($msg){
		$fichero = fopen(self::$fichero, "a");
		if (!$fichero) throw new ExcepcionRegistroAperturaFichero(self::$fichero);
		$msg = date(self::FORMATO_FECHA)." - ".$msg."\n";
		fwrite($fichero, $msg);
		fclose($fichero);
	}
}

/// 	Excepción de error en la apertura de fichero.
class ExcepcionRegistroAperturaFichero extends Excepcion{
	public function __construct($fichero){
		$titulo = "No se ha podido abrir el Registro de Operaciones.";
		$texto = "La aplicación no ha podido abrir el fichero '$fichero' para utilizarlo como Registro de Operaciones.";
		$solucionProgramador = "Compruebe los permisos sobre el fichero y sobre el directorio del fichero.";
		parent::__construct($titulo,$texto,$solucionProgramador);
	}
}
return true;	//Indicador de carga para __autoload
?>
